		lea (image_screen),a5
		move.l #$60000002,(a3) ;vram write $A000
		bsr termtextloop	
		
	    bsr read_controller1
		bsr imagetestinput
		bsr draw_image_cursor
		rte
	
draw_image_cursor:
		clr d0
		swap d0
		move.w imagecursorpos,d0
		bsr calc_vram
		move.l d0,(a3)
		move.w #$003c,(a4) ;<
		move.w #$002d,(a4) ;-
		move.w #$002d,(a4) ;-
		clr d0
		swap d0	
		move.w oldimagecursorpos,d0
		bsr calc_vram
		move.l d0,(a3)
		move.w #$0000,(a4)
		move.w #$0000,(a4)
		move.w #$0000,(a4)	
		rts	

imagetestinput:
		move.b d3,d7
		or.b #$fe,d7
		cmpi.b #$fe,d7
		beq imagecursorup
		move.b d3,d7
		or.b #$fd,d7
		cmpi.b #$fd,d7
		beq imagecursordown
		move.b d3,d7
		or.b #$df,d7
		cmpi.b #$df,d7
		beq load_image	
		rts			
		
imagecursorup:
		cmpi.w #$c430,imagecursorpos
		beq return
		move.w imagecursorpos,oldimagecursorpos
		sub.w #$0080,imagecursorpos
		bsr unhold		
		rts		
imagecursordown:
		cmpi.w #$C7b0,imagecursorpos
		bge return
		move.w imagecursorpos,oldimagecursorpos		
		add.w #$0080,imagecursorpos
		bsr unhold			
		rts	
		
load_image:
		cmpi.w #$c430,imagecursorpos
		beq load_bleedtest
		cmpi.w #$c4B0,imagecursorpos
		beq load_sharptest
		cmpi.w #$C530,imagecursorpos
		beq load_overscantest
		cmpi.w #$C5B0,imagecursorpos
		beq load_stripetest
		cmpi.w #$C630,imagecursorpos
		beq load_checkertest	
		cmpi.w #$C6B0,imagecursorpos
		beq load_grad1	
		cmpi.w #$C730,imagecursorpos
		beq load_grad2	
		cmpi.w #$C7b0,imagecursorpos
		beq load_grad3
		rts
		
load_bleedtest:
		move.w #$8134,(a3)		
		lea (img_bleed),a5
		lea (decompress_loc),a1
		bsr decompress
		move.w #$9300,(a3) 		;DMA length
		move.w #$9446,(a3)
		move.w #$9500,(a3)      ;00
		move.w #$9688,(a3)      ;10
		move.w #$977f,(a3)      ;ff
		move.l #$70000080,(a3)  ;DMA VRAM 3000
		bsr generate_map
		move.w #$8238,(a3)
		move.w #$8407,(a3)
		lea (palette_bleed),a5
		move.w #$0f,d4
		move.l #$c0000000,(a3)
		bsr vram_loop
		move.w #$8174,(a3)
		bra image_wait
load_sharptest:
		move.w #$8134,(a3)		
		lea (img_sharpness),a5
		lea (decompress_loc),a1
		bsr decompress
		move.w #$9300,(a3) 		;DMA length
		move.w #$9446,(a3)
		move.w #$9500,(a3)      ;00
		move.w #$9688,(a3)      ;10
		move.w #$977f,(a3)      ;ff
		move.l #$70000080,(a3)  ;DMA VRAM 3000
		bsr generate_map
		move.w #$8238,(a3)
		move.w #$8407,(a3)
		lea (palette_sharpness),a5
		move.w #$0f,d4
		move.l #$c0000000,(a3)
		bsr vram_loop
		move.w #$8174,(a3)
		bra image_wait
load_overscantest:
		move.w #$8134,(a3)		
		lea (img_overscan),a5
		lea (decompress_loc),a1
		bsr decompress
		move.w #$9300,(a3) 		;DMA length
		move.w #$9446,(a3)
		move.w #$9500,(a3)      ;00
		move.w #$9688,(a3)      ;10
		move.w #$977f,(a3)      ;ff
		move.l #$70000080,(a3)  ;DMA VRAM 3000
		bsr generate_map
		move.w #$8238,(a3)
		move.w #$8407,(a3)
		lea (palette_overscan),a5
		move.w #$0f,d4
		move.l #$c0000000,(a3)
		bsr vram_loop
		move.w #$8174,(a3)
		bra image_wait
load_stripetest:
		move.w #$8134,(a3)		
		lea (img_stripes),a5
		lea (decompress_loc),a1
		bsr decompress
		move.w #$9300,(a3) 		;DMA length
		move.w #$9446,(a3)
		move.w #$9500,(a3)      ;00
		move.w #$9688,(a3)      ;10
		move.w #$977f,(a3)      ;ff
		move.l #$70000080,(a3)  ;DMA VRAM 3000
		bsr generate_map
		move.w #$8238,(a3)
		move.w #$8407,(a3)
		lea (palette_stripes),a5
		move.w #$0f,d4
		move.l #$c0000000,(a3)
		bsr vram_loop
		move.w #$8174,(a3)
		bra image_wait
load_checkertest:
		move.w #$8134,(a3)		
		lea (img_checker),a5
		lea (decompress_loc),a1
		bsr decompress
		move.w #$9300,(a3) 		;DMA length
		move.w #$9446,(a3)
		move.w #$9500,(a3)      ;00
		move.w #$9688,(a3)      ;10
		move.w #$977f,(a3)      ;ff
		move.l #$70000080,(a3)  ;DMA VRAM 3000
		bsr generate_map
		move.w #$8238,(a3)
		move.w #$8407,(a3)
		lea (palette_checker),a5
		move.w #$0f,d4
		move.l #$c0000000,(a3)
		bsr vram_loop
		move.w #$8174,(a3)
		bra image_wait
load_grad1:
		move.w #$8134,(a3)		
		lea (img_grad1),a5
		lea (decompress_loc),a1
		bsr decompress
		move.w #$9300,(a3) 		;DMA length
		move.w #$9446,(a3)
		move.w #$9500,(a3)      ;00
		move.w #$9688,(a3)      ;10
		move.w #$977f,(a3)      ;ff
		move.l #$70000080,(a3)  ;DMA VRAM 3000
		bsr generate_map
		move.w #$8238,(a3)
		move.w #$8407,(a3)
		lea (palette_grad1),a5
		move.w #$0f,d4
		move.l #$c0000000,(a3)
		bsr vram_loop
		move.w #$8174,(a3)
		bra image_wait
load_grad2:
		move.w #$8134,(a3)		
		lea (img_grad1),a5
		lea (decompress_loc),a1
		bsr decompress
		move.w #$9300,(a3) 		;DMA length
		move.w #$9446,(a3)
		move.w #$9500,(a3)      ;00
		move.w #$9688,(a3)      ;10
		move.w #$977f,(a3)      ;ff
		move.l #$70000080,(a3)  ;DMA VRAM 3000
		bsr generate_map
		move.w #$8238,(a3)
		move.w #$8407,(a3)
		lea (palette_grad2),a5
		move.w #$0f,d4
		move.l #$c0000000,(a3)
		bsr vram_loop
		move.w #$8174,(a3)
		bra image_wait
load_grad3:
		move.w #$8134,(a3)		
		lea (img_grad1),a5
		lea (decompress_loc),a1
		bsr decompress
		move.w #$9300,(a3) 		;DMA length
		move.w #$9446,(a3)
		move.w #$9500,(a3)      ;00
		move.w #$9688,(a3)      ;10
		move.w #$977f,(a3)      ;ff
		move.l #$70000080,(a3)  ;DMA VRAM 3000
		bsr generate_map
		move.w #$8238,(a3)
		move.w #$8407,(a3)
		lea (palette_grad3),a5
		move.w #$0f,d4
		move.l #$c0000000,(a3)
		bsr vram_loop
		move.w #$8174,(a3)
		bra image_wait
		
image_wait:
		bsr unhold
image_waitloop:
		bsr read_controller1
		cmpi.b #$ff,d3
		beq image_waitloop
		move.w #$8134,(a3)				
		lea (palette),a5
		move.w #$3f,d4
		move.l #$c0000000,(a3)	
		bsr vram_loop		
		move.w #$8230,(a3)
		move.w #$8405,(a3)		
		bsr unhold
		move.w #$8174,(a3)		
		rts

		